/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function (window, document, RSVP, rJS, jIO) {
 "use strict";
 
 rJS(window)
 
 .ready(function(){
    var index, db;
    
    index = FlexSearch.create("memory");
    
    db = jIO.createJIO(
      {
      type : "indexeddb",
      database : "mynij"
      }
    );
    
    this.changeState({
      index : index,
      db : db,
      msgpack : msgpack
    });
    
    return this._load_index();
 })
 
 .declareMethod("get", function(id){
   return this.state.db.get(id);
 })
 
 .declareMethod("get_loaded", function(){
   var gadget = this;
   return this.state.db.get("loaded")
    .push(function(result){
      return result;
    })
    .push(undefined, function (my_error) {return null});
 })
 
 .declareMethod("add_page", function(page_info){ //page_info = {link, title, description, item}
    console.log(this.state.index.info());
    var gadget = this,
        tmp;
    tmp = page_info;
    tmp.portal_type = "page";
    return gadget.state.db.put(page_info.link, tmp)
      .push(function(){
        /*var defer = RSVP.defer();
        gadget.state.index.add(page_info.link, page_info.title + " " + page_info.item, defer.resolve.bind(defer));
        return defer.promise;*/
        return gadget.state.index.add(page_info.link, page_info.title + " " + page_info.item);
      });
 })
 
 .declareMethod("loaded", function(file_name){
    var gadget = this,
      id;
    console.log(file_name + " done loading");
      
    return gadget.state.db.get("loaded")
      .push(function(result){
        var tmp = result;
        tmp[file_name] = true;
        return gadget.state.db.put("loaded", tmp);
      })
      .push(undefined, function (my_error) {
        console.log(my_error);
        var tmp = {};
        tmp[file_name] = true;
        return gadget.state.db.put("loaded", tmp);
      })
      .always(function(){
        return gadget._save_index();
      });
 })
 
 .declareMethod("_save_index", function(){
/*    var gadget = this;
    console.log("getting index");
    var serialized = this.state.index.export_test();
    console.log("Index received. Saving");
    return this.state.db.put("index", this.state.index.info())
      .push(function(){
        console.log(1);
        //return gadget.state.db.putAttachment("index", "ids", new Blob([serialized.ids], {type : "application/json"}));
        return gadget.state.db.putAttachment("index", "ids", new Blob([serialized.ids], {type : "text/plain"}));
      })
      .push(function(){
        console.log(2);
        //return gadget.state.db.putAttachment("index", "map", new Blob([serialized.map], {type : "application/json"}));
        var shaObj = new jsSHA("SHA-1", "TEXT");
        shaObj.update(serialized.map);
        console.log("map sha1 : " + shaObj.getHash("HEX"));
        return gadget.state.db.putAttachment("index", "map", new Blob([serialized.map], {type : "text/plain"}));
      })
      .push(function(){
        console.log(3);
        //return gadget.state.db.putAttachment("index", "ctx", new Blob([serialized.ctx], {type : "application/json"}));
        return gadget.state.db.putAttachment("index", "ctx", new Blob([serialized.ctx], {type : "text/plain"}));
      })
      .push(function(){
        console.log("index saved");
      })
      .push(undefined, function (my_error) {
        throw my_error;
        //console.log(my_error);
      });*/
      
    var gadget = this,
      serialized,
      i,
      j = 0,
      promise_list = [];
    console.log("getting index");
    serialized = this.state.index.export_test();
    console.log("Index received. Saving");
    return this.state.db.put("index_map", {})
      .push(function(){
        console.log(serialized.map.slice(0, 1000));
        for (i = 0; i < serialized.map.length; i += 10000){
          promise_list.push(gadget.state.db.putAttachment("index_map", j+"", new Blob([serialized.map.slice(i, i+10000)], {type : "application/json"})));
          j+=1;
        }
        j = 0;
        return RSVP.all(promise_list);
      })
      .push(function(){
        return gadget.state.db.put("index_ids", {});
      })
      .push(function(){
        promise_list = [];
        for (i = 0; i < serialized.map.length; i += 10000){
          promise_list.push(gadget.state.db.putAttachment("index_ids", j+"", new Blob([serialized.ids.slice(i, i+10000)], {type : "application/json"})));
          j+=1;
        }
        j = 0;
        return RSVP.all(promise_list);
      })
      .push(function(){
        return gadget.state.db.put("index_ctx", {});
      })
      .push(function(){
        promise_list = [];
        for (i = 0; i < serialized.ctx.length; i += 10000){
          promise_list.push(gadget.state.db.putAttachment("index_ctx", j+"", new Blob([serialized.map.slice(i, i+10000)], {type : "application/json"})));
          j+=1;
        }
        return RSVP.all(promise_list);
      })
      .push(function(){
        console.log("index saved");
      })
      .push(undefined, function (my_error) {
        console.log(my_error);
      });
    
 })
 
 .declareMethod("search", function(query){
   return this.state.index.search(query);
 })
 
 .declareMethod("_load_index", function(msgpack){
/*    var gadget = this,
        ids,
        map;
    return gadget.state.db.getAttachment("index", "ids", {"format": "text"})
      .push(function(result){
        ids = result;
        return gadget.state.db.getAttachment("index", "map", {"format": "text"});
      })
      .push(function(result){
        map = result;
        var shaObj = new jsSHA("SHA-1", "TEXT");
        shaObj.update(map);
        console.log("map sha1 : " + shaObj.getHash("HEX"));
        return gadget.state.db.getAttachment("index", "ctx", {"format": "text"});
      })
      .push(function(result){
        gadget.state.index.import_test(ids, map, result);
        console.log("index imported from memory");
      })
      .push(undefined, function (my_error) {console.log(my_error)});*/
    var gadget = this,
      ids,
      map,
      ctx,
      promise_list = [],
      i;
    return gadget.state.db.allAttachments("index_ids")
      .push(function(result){
        if (Object.keys(result).length !== 0){
          for (i = 0; i < Object.keys(result).length; i+=1){
            promise_list.push(gadget.state.db.getAttachment("index_ids", i+"", {format : "text"}));
          }
          return RSVP.all(promise_list);
        } else {
          return null;
        }
      })
      .push(function(result){
        if (result === null) ids = "";
        else ids = result.join("");
        return gadget.state.db.allAttachments("index_map");
      })
      .push(function(result){
        if (Object.keys(result).length !== 0){
          for (i = 0; i < Object.keys(result).length; i+=1){
            promise_list.push(gadget.state.db.getAttachment("index_map", i+"", {format : "text"}));
          }
          return RSVP.all(promise_list);
        } else {
          return null;
        }
      })
      .push(function(result){
        console.log(result[0]);
        if (result === null) map = "";
        else map = result.join("");
        console.log(map.slice(0, 1000));
        return gadget.state.db.allAttachments("index_ctx");
      })
      .push(function(result){
        if (Object.keys(result).length !== 0){
          for (i = 0; i < Object.keys(result).length; i+=1){
            promise_list.push(gadget.state.db.getAttachment("index_ctx", i+"", {format : "text"}));
          }
          return RSVP.all(promise_list);
        } else {
          return null;
        }
      })
      .push(function(result){
        if (result === null) ctx = "";
        else ctx = result.join("");
        return gadget.add_index(ids, map, ctx);
      })
      .push(function(result){
        console.log("index imported from memory");
      })
      .push(undefined, function (my_error) {
        console.log(my_error);
      });
  })
    
  .declareMethod("is_empty", function(){
    return this.state.db.allDocs()
      .push(function(all_docs){
        return all_docs.data.total_rows === 0;
      });
  })
  
  .declareMethod("get_index", function(){
    console.log(this.state.index.info());
    //return this.state.index.export(this.state.msgpack);
    return this.state.index.export_test();
  })
  
  .declareMethod("add_index", function(ids, map, ctx){
    console.log("adding index");
    //this.state.index.import(serialized_index, this.state.msgpack);
    this.state.index.import_test(ids, map, ctx);
    console.log(this.state.index.info());
  });
 
}(window, document, RSVP, rJS, jIO));